#!/usr/bin/perl
# dns-getctx.pl
#Copyright © [2008(S)] Novell, Inc.  All Rights Reserved.
#THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND TREATIES.  
#IT MAY NOT BE USED, COPIED, DISTRIBUTED, DISCLOSED, ADAPTED, PERFORMED,
#DISPLAYED, COLLECTED, COMPILED, OR LINKED WITHOUT NOVELL'S PRIOR WRITTEN CONSENT.
#USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT
#THE PERPETRATOR TO CRIMINAL AND CIVIL LIABILITY.
#
#NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY, 
#INCLUDING WITHOUT THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
#PARTICULAR PURPOSE, AND NON-INFRINGEMENT. NOVELL, THE AUTHORS OF THE WORK,
#AND THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY CLAIM,
#DAMAGES, OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT,
#OR OTHERWISE, ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK OR THE 
#USE OR OTHER DEALINGS IN THE WORK.
#
# Author: Sulabh Sharma. feedback to ssulabh@novell.com
# 
#
 
# This perl script uses the NET::LDAP APIs to read contexts for the DNS objects

use Getopt::Std;
%args=();
getopt("s:p:l:a:d:u:",\%args);

$source = $args{s};
$port   = $args{p};
$ssl = $args{l};
$binddn = $args{a};
$dns = $args{d};
$case = $args{u};
$bindpasswd=$ENV{'OES_DATA'};

if ($source eq "" || $port eq "" || $ssl eq "" || $binddn eq "" || $dns eq "" || $case eq "")
{
&usage();
}

#$ENV{'DNSIP'}=$dns;
system(`nohup sh /opt/novell/eDirectory/bin/ndspath ndsstat -h "$dns" > /var/opt/novell/log/named/stat`);
open (NDSSTATFILE,"</var/opt/novell/log/named/stat")          
or &fileerror($!);

							#contains the list of migrated servers

open (OUTPUTFILE,">/opt/novell/named/bin/dns-ctx")          
or &fileerror($!);

$remotedns=3;
$ncpserverdn="";

while(<NDSSTATFILE>)
{

my $var = $_;
my $cn="";
if ($var ne "")
{
my @array = split (' ' , $var);
my $array = @array;
if (@array[0] eq "Server")
 { 
 my $y=0;
 my $dottedcn ="";
 for ($y=2;$y<$array;$y++)
{
 if($y ne 2)
 {
  $dottedcn .= " ";
 }
 $dottedcn .= @array[$y];
}
 my @commacn =  split ('\.' , $dottedcn); 
 my $commacn=@commacn;
 my $i;
 for( $i=0;$i<$commacn-1;$i++) 
   {    
	$cn .= @commacn[$i];
        if (@commacn[$i] ne "")
        {
        $cn .= ",";
 	}
   }
 chop $cn;
 $ncpserverdn=$cn;
 }

}
 
}

close(NDSSTATFILE);


if($ssl)
{
use Net::LDAPS;
use Net::LDAP::Util qw(ldap_error_text
                         ldap_error_name
                         ldap_error_desc
                        );                                              #SSL bind 
use Net::LDAP::Control;
use Net::LDAP::Constant qw( LDAP_CONTROL_MATCHEDVALS );

 $ctrl = Net::LDAP::Control->new(
   type     => "2.16.840.1.113719.1.513.4.5",
   value    => "",
   critical => 0
 );

$ldap = Net::LDAPS->new($source,
                          port => $port  ,control => [ $ctrl ]);
  if ($@ ne  "")
   {
    print stderr "Fatal:$@. An ldap error occurred.";
unlink("/var/opt/novell/log/named/stat");
close(OUTPUTFILE);
exit 1;

   }

}
else
{
use Net::LDAP;
use Net::LDAP::Util qw(ldap_error_text
                         ldap_error_name
                         ldap_error_desc
                        );                                             # Non-SSL bind
use Net::LDAP::Control;
use Net::LDAP::Constant qw( LDAP_CONTROL_MATCHEDVALS );

 $ctrl = Net::LDAP::Control->new(
   type     => "2.16.840.1.113719.1.513.4.5",
   value    => "",
   critical => 0
 );

$ldap = Net::LDAP->new($source,
                          port => $port ,control => [ $ctrl ]);
  if ($@ ne  "")
   {
    print stderr "Fatal:$@. An ldap error occurred.";
unlink("/var/opt/novell/log/named/stat");
close(OUTPUTFILE);
exit 1;

   }
}


 $mesg = $ldap->bind ($binddn, password => $bindpasswd);

#------------------------------------------------------ERROR --- 
 if (ldap_error_name($mesg) ne "LDAP_SUCCESS")
 {
print stderr "Fatal:";
print stderr ldap_error_name($mesg);
print stderr ": ";
print stderr ldap_error_text($mesg);
unlink("/var/opt/novell/log/named/stat");
close(OUTPUTFILE);
exit 1;

 }
#------------------------------------------------------ERROR ---


my $cn = &basecn($ncpserverdn,1);
my $base =  &basecn($ncpserverdn,0);
my $mesg = $ldap->search (
                                   base => $base,
                                   filter => "(&(commonname=$cn)(objectclass=NCPServer))");

#------------------------------------------------------ERROR ---
 if (ldap_error_name($mesg) ne "LDAP_SUCCESS")
 {
  print stderr $mesg;
unlink("/var/opt/novell/log/named/stat");
close(OUTPUTFILE);
exit 1;

 }
#------------------------------------------------------ERROR ---



my $max = $mesg->count;
my $entry = $mesg->entry;
@locator = $entry->get_value ("dNIPLocatorPtr");
$locatordn=@locator[0];
print OUTPUTFILE &basecn(@locator[0],0);
print OUTPUTFILE "\n";



$cn = &basecn($locatordn,1);
$base =  &basecn($locatordn,0);
$mesg = $ldap->search (
                                   base => $base,
                                   filter => "(&(commonname=$cn)(objectclass=dNIPLocator))");
#------------------------------------------------------ERROR ---
 if (ldap_error_name($mesg) ne "LDAP_SUCCESS")
 {
  print stderr $mesg;
unlink("/var/opt/novell/log/named/stat");
close(OUTPUTFILE);
exit 1;

 }
#------------------------------------------------------ERROR ---


my $entry = $mesg->entry;
@group = $entry->get_value ("dNIPGroupReference");
$group=@group;
if ($group eq 0)
{
unlink("/var/opt/novell/log/named/stat");
close(OUTPUTFILE);
exit 1;

}
print OUTPUTFILE &basecn(@group[0],0);
print OUTPUTFILE "\n";

if($case ne $remotedns)
{
my $entry = $mesg->entry;
@zones = $entry->get_value ("dNIPDNSZones");
$zones = @zones;
my $i;
for( $i=0;$i<$zones;$i++)
   {
   if((&basecn(@zones[$i],1)) eq "RootServerInfo")
    {
    print OUTPUTFILE &basecn(@zones[$i],0);
    print OUTPUTFILE "\n";
    $i=$zones;
    }
   }
}


if($case ne $remotedns)
{
$cn = &basecn(@group[0],1);
$base =  &basecn(@group[0],0);
$mesg = $ldap->search (
                                   base => $base,
                                   filter => "(&(commonname=$cn)(objectclass=Group))");
#------------------------------------------------------ERROR ---
 if (ldap_error_name($mesg) ne "LDAP_SUCCESS")
 {
  print stderr $mesg;
unlink("/var/opt/novell/log/named/stat");
close(OUTPUTFILE);
exit 1;

 }
#------------------------------------------------------ERROR ---
my $entry = $mesg->entry;
@member = $entry->get_value ("member");
$member=@member;
if ($member eq 0)
{
unlink("/var/opt/novell/log/named/stat");
close(OUTPUTFILE);
exit 1;

}

foreach $mem_val (@member)
{
	my $cn = &basecn($mem_val, 1);
	my $base = &basecn($mem_val, 0);
    
	my $mesg_usr = $ldap->search ( base => $base,
                   filter => "(&(commonname=$cn)(objectclass=User))" );

	if (ldap_error_name($mesg_usr) ne "LDAP_SUCCESS")
	{
  		print stderr $mesg_usr;
	} else {
		if ($mesg_usr->count > 0 ) {
			print OUTPUTFILE $mem_val;
			last;
		}	    
	}
}
print OUTPUTFILE "\n";
	
}


unlink("/var/opt/novell/log/named/stat");
close(OUTPUTFILE);
exit 0 ;




sub basecn ()                                           #BREAKS THE DN INTO CN AND BASE AND RETURNS WHAT IS ASKED FOR
{
local($zone, $b);
($zone, $b) = ($_[0], $_[1]);
my @zone = split(',',$zone);
my $cn =  @zone[0];
my @arrcn = split('=',$cn);
$cn =@arrcn[1];

shift (@zone);
$base = join(",",@zone);
if ($b eq 0)
 {
  return ($base);
 }
else
 {
  return($cn);
 }
}



sub fileerror()                                         #WRITES THE DETAILS OF THE FILE ERRORS INSIDE THE LOGFILE
{
my $var = $_[0];
print stderr $var;
print stderr "\n";
}

sub
usage()
{
print "Usage: perl  dns-getctx.pl [options]\n";
print "-s                Ldap Address\n";
print "-p                Ldap Port\n";
print "-l                SSL option (1 for ssl port and 0 for non ssl port)\n";
print "-a                Tree Admin DN\n";
print "-d                DNS IP\n";
print "-u                Use Case\n";
exit 1
}


