#!/bin/bash
# This script helps in creating and assigning rights to the required directories in the shared volume
#
# Copyright  [2007] Novell, Inc.  All Rights Reserved.

# THIS WORK IS SUBJECT TO U.S. AND INTERNATIONAL COPYRIGHT LAWS AND TREATIES.  IT MAY NOT BE USED, COPIED, 
# DISTRIBUTED, DISCLOSED, ADAPTED, PERFORMED, DISPLAYED, COLLECTED, COMPILED, OR LINKED WITHOUT NOVELL'S PRIOR 
# WRITTEN CONSENT.  USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO CRIMINAL 
# AND CIVIL LIABILITY.

# NOVELL PROVIDES THE WORK "AS IS," WITHOUT ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING WITHOUT THE IMPLIED WARRANTIES 
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT. NOVELL, THE AUTHORS OF THE WORK, AND 
# THE OWNERS OF COPYRIGHT IN THE WORK ARE NOT LIABLE FOR ANY CLAIM, DAMAGES, OR OTHER LIABILITY, WHETHER IN AN ACTION 
# OF CONTRACT, TORT, OR OTHERWISE, ARISING FROM, OUT OF, OR IN CONNECTION WITH THE WORK OR THE USE OR OTHER DEALINGS 
# IN THE WORK.





usage() {
    echo "Usage: ./ncs_dir.sh MountPath [Username]";
    echo "Example: ./ncs_dir.sh /media/nss/DNSVOL/ cn=admin.o=novell.T=MyTree";
    echo "The Username is used for nss volumes";
    exit
}

if [ $# -lt 1 ]  #checking the number of arguments. The second argument Username is optional
then
    echo "";
    echo "Insufficient Argument"
    usage
fi
mountpath=$1 #store the mountpath

if [ -n "$2" ] #Does the second argument (username) exsists?
then
    var=`echo $2 | grep -ci ".T="`; #The username exsists and check it has the FQDN format. It is not so intelligent. Just parse it.
    if [ "$var" -eq "0" ] 
    then 
	echo ""
	echo "Are you sure you have mentioned the tree name?";
	usage
    fi
    username=$2
fi

#Make directories 
mkdir -p "$mountpath/etc/opt/novell/named";
#mkdir -p "$mountpath/var/opt/novell/log/named";

#change ownershipe of the created directories
sudo chown named:named "$mountpath/etc/opt/novell/named"
#sudo chown named:named "$mountpath/var/opt/novell/log/named";

#if nss assign rights too
if [ -n "$username" ]
then
    rights -f "$mountpath/etc/opt/novell/named" -r rwfcem trustee $username
#    rights -f "$mountpath/var/opt/novell/log/named" -r rwfcem trustee $username
fi
echo "Done.";

